/*
  MCP3201.cpp - Library for reading 12bit Data from a MCP3201.
  Created by Stephen Leahey <stephenleahey@gmail.com>
  Sample code provided by Arduino Forum member halabut
*/

#include <WProgram.h>
#include <MCP3201.h>

MCP3201::MCP3201(int CS_pin, int DI_pin, int SCK_pin)
{
  pinMode(CS_pin, OUTPUT);
  pinMode(DI_pin, INPUT);
  pinMode(SCK_pin, OUTPUT);
  
  digitalWrite(CS_pin, HIGH);
  
  _CS_pin = CS_pin;
  _DI_pin = DI_pin;
  _SCK_pin = SCK_pin;
}

int MCP3201::readMcp3201()
{
  int adcvalue = 0;
/* 
  Using 1uS delays here, so effectively the device communicates at 500kHz
  The device has an upper speed limit of 1.6Mhz, but implementation is very
  easy if we let it run slow. This could be improved...
*/
  digitalWrite(_CS_pin,LOW); 	//Select adc
  delayMicroseconds(1);
  digitalWrite(_SCK_pin,HIGH);  //ignores 2 null bits
  delayMicroseconds(1);
  digitalWrite(_SCK_pin,LOW);
  delayMicroseconds(1);
  digitalWrite(_SCK_pin,HIGH);
  delayMicroseconds(1);
  digitalWrite(_SCK_pin,LOW);
  delayMicroseconds(1);
  
  //read bits from adc
  for (int i=12; i>=0; i--){
    adcvalue+=digitalRead(_DI_pin)<<i;
    //cycle clock
    digitalWrite(_SCK_pin,HIGH);
	delayMicroseconds(1);
    digitalWrite(_SCK_pin,LOW);
	delayMicroseconds(1);
  }
  digitalWrite(_CS_pin, HIGH); //turn off device
  return adcvalue;
}
